/*+
|                                               |
|     Function: EXTRACT_TEL                     |
|                                               |
|      Extrair somente o nmero do telefone     |
|      Ex.: (31) 2122-2300 => 3121222300        |
|                                               |
|     Criao:                                  |
|     16/11/2007 - Danilo Faria                 |
|                                               |
+*/


IF EXISTS(SELECT NAME FROM SYSOBJECTS
          WHERE NAME = 'EXTRACT_TEL' AND TYPE = 'FN')
   DROP FUNCTION EXTRACT_TEL

GO

CREATE
FUNCTION EXTRACT_TEL(
       @P_NRTELEFONE VARCHAR(50)
       ) RETURNS VARCHAR(50)
AS
BEGIN
   DECLARE @V_NRTELEFONE      VARCHAR(50);
   DECLARE @V_NRTEL_OK        CHAR(1);
   DECLARE @V_EXTRACTED_TEL   VARCHAR(50);
   DECLARE @V_RETURN          VARCHAR(50);

   DECLARE @V_LENGTH          INTEGER;

------------------------------------------

   SET @V_NRTELEFONE    = NULL;
   SET @V_NRTEL_OK      = NULL;
   SET @V_EXTRACTED_TEL = ' '; --> Se for inicializado como null, no consegue concatenar depois
   SET @V_RETURN        = ' ';

   SET @V_LENGTH        = 0;

------------------------------------------

   SET @V_NRTELEFONE = SUBSTRING(@P_NRTELEFONE, 1,  CHARINDEX('/', SUBSTRING(@P_NRTELEFONE+'/', 1, 50)));

   SET @V_LENGTH =  LEN(@V_NRTELEFONE);

   WHILE @V_LENGTH > 0 BEGIN

      SET @V_NRTEL_OK = SUBSTRING(@V_NRTELEFONE, @V_LENGTH,  1);
      
      IF @V_NRTEL_OK NOT IN('0', '1', '2', '3', '4', '5', '6', '7', '8', '9') BEGIN
         SET @V_NRTEL_OK = ''; --> No permitir valores no numricos
      END;      

      IF @V_NRTEL_OK IS NOT NULL BEGIN
         SET @V_EXTRACTED_TEL = @V_EXTRACTED_TEL + @V_NRTEL_OK; 
      END;

      SET @V_LENGTH = @V_LENGTH - 1;
   END;
   
   SET @V_LENGTH =  LEN(@V_EXTRACTED_TEL);

   WHILE @V_LENGTH > 0 BEGIN --> Reverter o nmero: Antes = '0032221213', Depois = '3121222300'
      SET @V_NRTEL_OK = SUBSTRING(@V_EXTRACTED_TEL, @V_LENGTH,  1);

      IF @V_NRTEL_OK IS NOT NULL BEGIN
         SET @V_RETURN = @V_RETURN + @V_NRTEL_OK; 
      END;

      SET @V_LENGTH = @V_LENGTH - 1;         
   END;
 
   SET @V_RETURN = REPLACE(@V_RETURN, ' ', '');
   RETURN (@V_RETURN);
END

GO

-- VERSAO --
EXEC ATUVEROBJ 'EXTRACT_TEL','5.01.002';

GO
